"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WebimSubscription = void 0;
exports.isWebimError = isWebimError;
exports.parseNativeResponse = parseNativeResponse;
exports.processError = processError;
exports.webimErrorHandler = webimErrorHandler;
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function parseNativeResponse(response) {
  return response || null;
}
function isWebimError(err) {
  const errorFields = Object.keys(err);
  return errorFields.includes('errorCode') && errorFields.includes('errorType');
}
function processError(error) {
  return new Error(error.errorCode);
}
class WebimSubscription {
  constructor(remove) {
    _defineProperty(this, "remove", void 0);
    this.remove = remove;
  }
}

/**
 * Parse error object, map it into {@link WebimNativeError} and decide should be thrown or not.
 *
 * @param {*} err - A caught error-object on Promise-level.
 * @param {boolean} [throwable=true] - Optional parameter to define throw immediately
 * or take error result and handle by your-self.
 *
 * @return {WebimNativeError} In case of not throwable.
 *
 * @throws {WebimNativeError}
 */
exports.WebimSubscription = WebimSubscription;
function webimErrorHandler(err) {
  var _err$userInfo, _err$userInfo2, _err$userInfo3;
  let throwable = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  const errorBody = {
    errorCode: (err === null || err === void 0 ? void 0 : (_err$userInfo = err.userInfo) === null || _err$userInfo === void 0 ? void 0 : _err$userInfo.errorCode) || err.errorCode || (err === null || err === void 0 ? void 0 : err.code) || 'UNKNWON',
    message: (err === null || err === void 0 ? void 0 : (_err$userInfo2 = err.userInfo) === null || _err$userInfo2 === void 0 ? void 0 : _err$userInfo2.message) || (err === null || err === void 0 ? void 0 : err.message) || 'Unexpected error',
    errorType: (err === null || err === void 0 ? void 0 : (_err$userInfo3 = err.userInfo) === null || _err$userInfo3 === void 0 ? void 0 : _err$userInfo3.errorType) || (err === null || err === void 0 ? void 0 : err.errorType) || 'common'
  };
  if (throwable) {
    throw errorBody;
  }
  return errorBody;
}
//# sourceMappingURL=utils.js.map