import { EmitterSubscription } from 'react-native';
import type { AttachFileResult, DialogClearedListener, ErrorListener, FileUploadingListener, NewMessageListener, Operator, RemoveMessageListener, SessionBuilderParams, StateListener, TokenUpdatedListener, TypingListener, UnreadCountListener, UpdateMessageListener, WebimEventListener, WebimMessage } from './types';
import { WebimEvents } from './types';
import { WebimSubscription } from './utils';
export declare class RNWebim {
    static initSession(params: SessionBuilderParams): Promise<void>;
    static resumeSession(): Promise<void>;
    static pauseSession(): Promise<void>;
    static destroySession(clearData?: boolean): any;
    static getLastMessages(limit?: number): Promise<WebimMessage[]>;
    static getNextMessages(limit?: number): Promise<WebimMessage[]>;
    static getAllMessages(): Promise<WebimMessage[]>;
    static send(message: string): Promise<string>;
    static readMessages(): Promise<void>;
    static rateOperator(rate: number): any;
    static getCurrentOperator(): Promise<Operator>;
    static tryAttachFile(): Promise<AttachFileResult>;
    static sendFile(uri: string, name: string, mime: string, extension: string): Promise<{
        id: string;
    }>;
    static tryAttachAndSendFile(): Promise<{
        id: string;
    }>;
    static addTypingListener(listener: TypingListener): WebimSubscription;
    static addFileUploadingListener(listener: FileUploadingListener): WebimSubscription;
    static addUnreadCountListener(listener: UnreadCountListener): WebimSubscription;
    static addNewMessageListener(listener: NewMessageListener): WebimSubscription;
    static addRemoveMessageListener(listener: RemoveMessageListener): WebimSubscription;
    static addEditMessageListener(listener: UpdateMessageListener): WebimSubscription;
    static addDialogClearedListener(listener: DialogClearedListener): WebimSubscription;
    static addTokenUpdatedListener(listener: TokenUpdatedListener): WebimSubscription;
    static addErrorListener(listener: ErrorListener): WebimSubscription;
    static addSateListener(listener: StateListener): WebimSubscription;
    static addListener(event: WebimEvents, listener: WebimEventListener): WebimSubscription;
    static removeListener(listener: EmitterSubscription): void;
    static removeAllListeners(event: WebimEvents): void;
}
export * from './types';
export * from './utils';
export * from './webimNativeError';
export default RNWebim;
//# sourceMappingURL=index.d.ts.map