import type { WebimNativeError } from './types';
export declare function parseNativeResponse<T>(response?: T): T | null;
export declare function isWebimError(err: any): err is WebimNativeError;
export declare function processError(error: WebimNativeError): Error;
export declare class WebimSubscription {
    readonly remove: () => void;
    constructor(remove: () => void);
}
/**
 * Parse error object, map it into {@link WebimNativeError} and decide should be thrown or not.
 *
 * @param {*} err - A caught error-object on Promise-level.
 * @param {boolean} [throwable=true] - Optional parameter to define throw immediately
 * or take error result and handle by your-self.
 *
 * @return {WebimNativeError} In case of not throwable.
 *
 * @throws {WebimNativeError}
 */
export declare function webimErrorHandler(err: any, throwable?: boolean): WebimNativeError;
//# sourceMappingURL=utils.d.ts.map